'''
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecucion de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento
La variable veces define las veces que se va a hacer el ordenamiento
Al final se imprimen los promedios de cada algortimo
'''

import time
from random import randint

import heap
from merge import merge

# Python program for implementation of MergeSort

# Merges two subarrays of arr[].
# First subarray is arr[l..m]
# Second subarray is arr[m+1..r]

def mergeSort(lista, l, r):
	if l < r:
      # Same as (l+r)//2, but avoids overflow for
      # large l and h
		m = l+(r-l)//2
      # Sort first and second halves
		mergeSort(lista, l, m)
		mergeSort(lista, m+1, r)
		merge(lista, l, m, r)

''' Luis Andrés López Mañán
    Program written by hand as a draft on 09/19/2022
    Credit goes to GeeksForGeeks
    Link: https://www.geeksforgeeks.org/python-program-for-heap-sort/
    Last access on 09/19/2022
    Program wrriten and edited on 10/10/2022
'''

# Python program for implementation of heap Sort (Part II)

def heapSort(lista):
	# Se busca el tamaño de la lista
	n = len(lista)
	heap.heapify(lista,n,0)
 
	''' Se crea un heap máximo y el último padre estará en
		la posición h1, i.e., la mitad del tamaño de la lista.
		Por lo tanto, ese sería el comienzo. 
	'''
	h1 = (n // 2) - 1
	for i in range(h1, -1, -1):
		heap.heapify(lista, n, i)
  
	# Se extrae los elementos uno a uno
	h2 = n - 1
	for i in range(h2, 0, -1):
		# Se intercambia, luego se hace heapify
		lista[i], lista[0] = lista[0], lista[i]
		heap.heapify(lista, 0, i)
  
	return lista

def quickSort(lista):
	# definan el algoritmo de ordenamiento quicksort
	elements = len(lista)
    
    # Base case
	if elements < 2:
		return lista
    
	current_position = 0 #Position of the partitioning element

	for i in range(1, elements): #Partitioning loop
		if lista[i] <= lista[0]:
			current_position += 1
			temp = lista[i]
			lista[i] = lista[current_position]
			lista[current_position] = temp

	temp = lista[0]
	lista[0] = lista[current_position] 
	lista[current_position] = temp #Brings pivot to it's appropriate position
    
	left = quickSort(lista[0:current_position]) #Sorts the elements to the left of pivot
	right = quickSort(lista[current_position+1:elements]) #sorts the elements to the right of pivot

	lista = left + [lista[current_position]] + right #Merging everything together
	return lista

''' 
	This algorithm was taken from: https://www.programiz.com/dsa/shell-sort 
	and was adapted in order to work for this assigment.
'''

def shellSort(lista):
	# definan el algoritmo de ordenamiento shellsort

	# determening the size of the list and calculates the gap value. 
	n = len(lista)
	gap = n // 2

	# this algorithm will run until gap reaches 1 
	while gap > 0:
		for i in range(gap, n):
			temp = lista[i] # storing all items from the list into temp 
			j = i 

			# compares the number in temp with the 0th possition (start of list)
			# if temp is larger than the first element then we swap them
			while j >= gap and lista[j - gap] > temp: 
				lista[j] = lista[j - gap]
				j -= gap

			lista[j] = temp
		gap = gap // 2 # decreases the gap to continue the loop 

	return lista

maxValor=1000 	#define el valor maximo de los elementos de la lista
largoLista=1000 #define el largo de las listas a ordenar
veces=100 		#define las veces que se va a hacer el ordenamiento 

acumulaMerge=0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap=0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick=0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell=0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	mergelista = [randint(0,maxValor) for r in range(largoLista)] #creamos una lista con valores al azar
	heaplista=list(mergelista)
	quicklista=list(mergelista)
	searchlista=list(mergelista)

	t1 = time.process_time()					#tomamos el tiempo inicial
	mergeSort(mergelista,0,len(mergelista)-1) 	#ejecutamos el algoritmo mergeSort
	acumulaMerge+=time.process_time() - t1		#acumulamos el tiempo de ejecucion
	# print(mergelista)							#desplegamos la lista

	t1 = time.process_time()				#tomamos el tiempo inicial
	heapSort(heaplista)					    #ejecutamos el algoritmo heapSort
	acumulaHeap+=time.process_time() - t1 	#acumulamos el tiempo de ejecucion
	# print(heaplista)						#desplegamos la lista

	t1 = time.process_time()				#tomamos el tiempo inicial
	quickresult = quickSort(quicklista)					#ejecutamos el algoritmo quickSort
	acumulaQuick+=time.process_time() - t1	#acumulamos el tiempo de ejecucion
	# print(quicklista)						#desplegamos la lista

	t1 = time.process_time()				#tomamos el tiempo inicial
	shellSort(searchlista)					#ejecutamos el algoritmo shellSort
	acumulaShell+=time.process_time() - t1	#acumulamos el tiempo de ejecucion
	# print(searchlista)						#desplegamos la lista

# imprimos los resultados
print ("Promedio de tiempo de ejecucion de "+ str(veces) +" listas de largo " + str(largoLista))
print ("MergeSort " + str(acumulaMerge/veces) + " segundos")
print ("HeapSort " + str(acumulaHeap/veces) + " segundos")
print ("QuickSort " + str(acumulaQuick/veces) + " segundos")
print ("ShellSort " + str(acumulaShell/veces) + " segundos")
